procedure BFS(var (* for speed *) G: graph);
  var i, j: vertex;
      p: PtrToNode;
      seen: array [vertex] of boolean;
        (* seen[ ] marks nodes as visited or in queue of nodes to be visited. *)

  (* Program assumes a queue package with operations
       procedure CreateQueue, function IsEmptyQueue: boolean,
       procedure Enqueue(v: vertex), and procedure Dequeue(var v: vertex). *)

  begin
    (* Initially, no vertices are visited or in the queue to be visited. *)
    CreateQueue;
    for i := 1 to G.size do seen[i] := false;

    (* The outer loop tries each vertex in turn as the starting point;
       thus all components will be traversed. *)
    for i := 1 to G.size do
      if not seen[i] (* actually "not visited[i]" at this point *)
        then begin (* component traversal *)
               (* Initialize by enqueueing initial vertex. *)
               Enqueue(i);
               seen[i] := true;

               while not IsEmptyQueue do
                 begin
                   (* Dequeue the next node seen but not yet visited
                      and visit it... *)
                   Dequeue(j);
                   visit(j);

                   (* ...and now queue all unseen neighbors of j. *)
                   p := G.AdjLists[j];
                   while p <> nil do
                     begin
                       if not seen[p^.id]
                         then begin
                                Enqueue(p^.id);
                                seen[p^.id] := true
                              end;
                      (* else ignore it--either it has been visited
                         or it is in the queue of nodes to be visited *)
                       p := p^.next
                     end
                 end
             end
  end; (* BFS *)
