const Max = ...; TwiceMax = ... (* 2*Max *);

type segments = array [1..Max] of segment;
     pointrec = record
                  left: boolean; (* true if left-hand endpoint *)
                  index: integer (* points to segment *)
                end;

function Intersection(    n: integer;
                      var (* for speed *) collection: segments): boolean;
  (* Determines whether or not there exists at least one intersecting
     pair in the input collection of n <= Max segments. *)
  label 99;
  var points: array [1..TwiceMax] of pointrec;
      s, sabove, sbelow: segment;
      i: integer;

  (* We assume the existence of a red-black search tree package
     providing operations
       procedure CreateRBTree, 
       procedure Insert(s: segment; var predecessor, successor: segment), and
       procedure Delete(s: segment; var predecessor, successor: segment).
     These operations compute keys on the fly; the key used is the ordinate
     of the point on the segment at the abscissa determined by the left
     (for insertion) or right (for deletion) endpoint of the segment s
     (for vertical segments, the key is the ordinate of the left endpoint).
  *)

  begin
    (* Initialization *)
    (* Set up points[ ] *)
    (* Sort points[ ] using Compare( )--suitably modified so that,
       in case of ties, left endpoints precede right endpoints. *)
    (* Initialize the tree package and insert two horizontal sentinel
       segments, which will never be deleted.  These segments should fall
       above and below all other segments and extend past them on the left
       and right. *)
    ...
    (* Loop through endpoints until done or until intersection detected. *)
    for i := 1 to 2*n do
      with points[i] do
        begin
          s := collection[index]; (* get segment in question *)
          if left
            then begin
                   Insert(s,sbelow,sabove);
                   if Intersect(s,sbelow) or Intersect(s,sabove)
                     then begin
                            Intersection := true;
                            goto 99 (* return *)
                          end
                 end
            else begin
                   Delete(s,sbelow,sabove);
                   (* sabove and sbelow are now adjacent in the order;
                      hence we must check them for intersection. *)
                   if Intersect(sbelow,sabove)
                     then begin
                            Intersection := true;
                            goto 99 (* return *)
                          end
                 end
        end;
    Intersection := false;
99: (* return *)
  end; (* Intersection *)
