function OnSegment(p: point; s: segment): boolean;
  (* Determine whether point p lies on segment s.
     Routine works even if the segment degenerates to a point. *)
  begin
    (* First determine whether p lies on the line passing through s. *)
    if WhichSide(p,s) = 0
      then (* If so, determine whether the point lies within the segment. *)
           OnSegment := (Compare(p,LesserOf(s.e1,s.e2)) >= 0) and
                        (Compare(p,GreaterOf(s.e1,s.e2)) <= 0)
      else OnSegment := false
  end; (* OnSegment *)
